﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		瓦千鳥（あるふぁ～秘密基地）									*/
/*	製作開始	2011/04/15														*/
/*	MAIL		dij@estate.ocn.ne.jp											*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2011/04/15	tamakoroベースに作成開始	2008/05/22	tamakoro 初版をベース	*/
/*	2011/04/30	ver 1.00リリース												*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用     #00A変数設定はここ～
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count;			// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int menu_input = 0;				//敵を倒したときのWAITカウンタ

	int mode; 						//ゲームのモード
	int hi_score[10] = 0;			//ハイスコア
	int game_score = 0;				//スコア
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int field_x = 50;				//表示位置
	int field_y = 50;				//表示位置
	int card_max = 6 * 10;			//カードの枚数 4色同数字2枚ずつで8枚×数字の種類 最大80まで
	int card_count = 0;				//取得カード数
	int cardlock1 = 99;				//1枚目
	int cardlock2 = 99;				//2枚目
	int game_end = 99;				//組みができないかのチェック
	int bonus = 0;					//基本点
	int bonus1 = 0;					//ペアボーナス
	int bonus_c = 0;				//colorコンボボーナス
	int bonus_n = 0;				//numberコンボボーナス
	int bonus_color = 0;			//ペアボーナス色系
	int bonus_signal = 0;			//ペアボーナス色系
	int bonus_number = 0;			//ペアボーナス数系
	int bonus_step = 0;				//ペアボーナス数系
	int bonus_8bit = 0;				//ペアボーナス数系
	int wait_time = 60*60*3;		//裏返し時間
	int bg_r = 0 ;					//背景色
	int bg_g = 0 ;					//背景色
	int bg_b = 100 ;				//背景色
	int bg_r2 = 0 ;					//背景色
	int bg_g2 = 0 ;					//背景色
	int bg_b2 = 100 ;				//背景色
	int effect_c[30] = 0 ;			//色bonusエフェクト用
	int effect_n[30] = 0 ;			//数bonusエフェクト用
	int effect_deg[30] = 0 ;		//エフェクト用角度
	int effect_count[30] =0 ;		//エフェクト用カウント

	float zoome =1;					//マップのズーム
	int ani_count = 0;				//アニメカウンタ
	int ani_frame = 0;				//変化フレーム数
	
	struct UNIT	{
				 int type;						//色種類 0-3,4
				 int num;						//数字   0-9
				 int state;						//状態 0 free 1 lock 2-10 effect & erase
				 int deg;						//角度
				 float speed;					//速度
				 int wait;						//表示時間

				float x;						//x座標
				float y;						//y座標
				int muki;						//向き 右1 左-1
				int size;						//中央までの距離
				int ani;						//アニメフレーム
				int status;						//状態 0立ち 1歩き 3忍歩き 4忍立ち 5降 6張 21飛 32失敗 33成功
				}
	UNIT card[100];

	UNIT player[2];
	
	
	Keypad keypad;					// キーボード/ゲームパッド取得用
	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化     #01
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("aira","resource/image/player.bmp" , [0,255,0]);

		
		
		Hell_loadTexture("tama","resource/image/tama.bmp" , [0,255,0]);

		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);

		Hell_loadWAV("get",         "resource/sound/l1.wav");
		Hell_loadWAV("door",        "resource/sound/puwa.wav");
		Hell_loadWAV("miss",        "resource/sound/damage.wav");
		Hell_loadWAV("select",        "resource/sound/select.wav");
		Hell_loadWAV("cancel",        "resource/sound/puwa.wav");
		Hell_loadWAV("destroy",        "resource/sound/destroy2.wav");
		Hell_loadWAV("powerup",        "resource/sound/clear.wav");

		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         999999);
			savedata.set("HI_SCORE1",         999999);
			savedata.set("HI_SCORE2",         999999);
			savedata.set("HI_SCORE3",         999999);
			savedata.set("HI_SCORE4",         999999);
			savedata.set("HI_SCORE5",         999999);
			savedata.set("HI_SCORE6",         999999);
			savedata.set("HOSHI",         1);
			savedata.write();
		}
		hi_score[0] = savedata.getint("HI_SCORE");
		hi_score[1] = savedata.getint("HI_SCORE1");
		hi_score[2] = savedata.getint("HI_SCORE2");
		hi_score[3] = savedata.getint("HI_SCORE3");
		hi_score[4] = savedata.getint("HI_SCORE4");
		hi_score[5] = savedata.getint("HI_SCORE5");
		hi_score[6] = savedata.getint("HI_SCORE6");

		game_time_count = 60*60*3;		//ゲーム終了までの残り時間
		mode = Hell_GetGameflag(10);	//ゲームモード

	//初期ステータス決定
	int j;
	int k;

		player[0].x = 250;
		player[0].y = 250;
		player[0].muki = 1;
		player[0].size = 16;
		
		
		
		

		
Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;
	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		if ( stage_start_count < ( 60 * 3 ) )
		{
			stage_start_count++;
		}
		else 
		{
			Hell_playBgm( "resource/sound/bgm_mogmog.ogg", -1, 0 );
			iSceneStatus = SCENE.MAIN;
			stage_start_count = 0;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		if ( stage_start_count > ( 60 * 2 ) )
		{
			Hell_drawFont(" GO! " , 155, 200 , 4 , 255,255,255);
		}
		else
		{
			Hell_drawFont("READY" , 150, 200 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if(Hell_isPushMouse() & HELL_BUTTON_LEFT)
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);

		Hell_drawFont( "RESULTS" , 110, 160 , 4 , 255,255,255);
		Hell_drawFont( "SCORE" ,    175, 200 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( game_score ) , 140, 230 , 4 , 255,255,255);
		if ( hi_score[mode] <= game_score )
		{
			Hell_drawFont( " NEW RECORD ",75, 280 , 3 , 255,50,50);
		}

		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PRESS mouse L BUTTON TO EXIT" , 100, 440 , 2 , 255,255,255);
		}
		else
		{
//			Hell_drawFont(" OWARI !" , 200, 420 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			system_move( );

			break;
		case SCENE.CLEAR:
			//クリア
//			effect_move( );
//			mob_move( );
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			system_draw( );

			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			system_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
			system_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理 #20A
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		int j;
		//残り時間のカウント
		game_time_count--;
		
		player_move();

//		if(Hell_isPushMouse() & HELL_BUTTON_LEFT)	//マウス左クリック
//		{
//		}
		
			if ( ( card_count == card_max ) || ( game_time_count <=0 ) || ( game_end == 0 ) )
		{
			
			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
//			game_score = game_time_count;
			if ( ( hi_score[0] < game_score ) && ( mode == 0 ) )
			{
				keypad.save( "replay/replay_00.bin" );	//リプレイの保存
				hi_score[0] = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score[0]);
				savedata.write();
			}
			if ( ( hi_score[1] < game_score ) && ( mode == 1 ) )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score[1] = game_score;
				savedata.set("HI_SCORE1",   cast(int)hi_score[1]);
				savedata.write();
			}
			if ( ( hi_score[2] < game_score ) && ( mode == 2 ) )
			{
				keypad.save( "replay/replay_02.bin" );	//リプレイの保存
				hi_score[2] = game_score;
				savedata.set("HI_SCORE2",   cast(int)hi_score[2]);
				savedata.write();
			}
			if ( ( hi_score[3] < game_score ) && ( mode == 3 ) )
			{
				keypad.save( "replay/replay_03.bin" );	//リプレイの保存
				hi_score[3] = game_score;
				savedata.set("HI_SCORE3",   cast(int)hi_score[3]);
				savedata.write();
			}
			if ( ( hi_score[4] < game_score ) && ( mode == 4 ) )
			{
				keypad.save( "replay/replay_04.bin" );	//リプレイの保存
				hi_score[4] = game_score;
				savedata.set("HI_SCORE4",   cast(int)hi_score[4]);
				savedata.write();
			}
			if ( ( hi_score[5] < game_score ) && ( mode == 5 ) )
			{
				keypad.save( "replay/replay_05.bin" );	//リプレイの保存
				hi_score[5] = game_score;
				savedata.set("HI_SCORE5",   cast(int)hi_score[5]);
				savedata.write();
			}
			if ( ( hi_score[6] < game_score ) && ( mode == 6 ) )
			{
				keypad.save( "replay/replay_06.bin" );	//リプレイの保存
				hi_score[6] = game_score;
				savedata.set("HI_SCORE6",   cast(int)hi_score[6]);
				savedata.write();
			}

			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
//				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
	}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	主人公の動き 	110503-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void player_move( )
	{
		ani_count++;
		if (ani_count >= ani_frame )
		{
			ani_count = 0;
			player[0].ani++;
			if (player[0].ani >=8 )
			{
				player[0].ani=0;
			}
		}
		
		
		if ((keypad.isPressRight() == 0 ) && (keypad.isPressLeft()) == 0 )	//ニュートラル
		{
//			Hell_playWAV( "door", 0, -1 );
			player[0].status = 0;
			player[0].ani = 0;
			ani_count = 0;
			ani_frame = 20;
		}
		
		if (keypad.isPressRight())		//コマンド→
		{
			player[0].muki = 1;
			if ( player[0].status == 0 )
			{
			player[0].status = 1;
			player[0].ani = 0;
			ani_count = 0;
			ani_frame = 5;
			}
		} 

		if (keypad.isPressLeft())		//コマンド←
		{
			player[0].muki = -1;
			if ( player[0].status == 0 )
			{
			player[0].status = 1;
			player[0].ani = 0;
			ani_count = 0;
			ani_frame = 5;
			}
		} 
		
		if (keypad.isPressUp())			//コマンド↑
		{
			zoome = zoome + 0.1;
			if ( zoome >= 3 ) 
			{
				zoome = 3;
			}
		} 

		if (keypad.isPressDown())		//コマンド↓
		{
			zoome = zoome - 0.1;
			if ( zoome <= 0.5 ) 
			{
				zoome = 0.5;
			}
		} 

		if(keypad.isPushEnter())		//1ボタン
		{
		}
		
		if(keypad.isPushCancel())		//2ボタン
		{
		}
		
		if (Hell_isPushJButton(2,0))	//3ボタン　キーボードの割り当てがわからん(汗
		{
//			Hell_playWAV( "door", 0, -1 );
		}

	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画 #20B
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//1	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		int j;
		int k;
		int c2 = 0;
		int combo_y = 150;
		int lock_y = -100;
		
		
		
		if ( bg_r < bg_r2)
		{
			bg_r = bg_r + 2;
		}else if ( bg_r > bg_r2)
		{
			bg_r = bg_r - 2;
		}
		if ( bg_g < bg_g2)
		{
			bg_g = bg_g + 2;
		}else if ( bg_g > bg_g2)
		{
			bg_g = bg_g - 2;
		}
		if ( bg_b < bg_b2)
		{
			bg_b = bg_b + 2;
		}else if ( bg_b > bg_b2)
		{
			bg_b = bg_b - 2;
		}
		
		Hell_drawRect( 10, 10,
					640 -10, 480 -10,
					0, 0, 
					bg_r, bg_g, bg_b, 
					255);							//前画面枠
		Hell_drawRect( field_x, field_y,
					300 + 32, 300 + 32,
					0, 0, 
					0,0,0, 
					255);							//フィールド枠
		
		Hell_setAlpha(HELL_ALPHA_NORMAL);

		Hell_drawFont( "SCORE" , 400, 80 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( game_score ) , 410, 110 , 4 , 255,255,255);

		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( hi_score[mode] ) , 410, 30 , 4 , 255,255,255);
	
		




		//debug Disp
//		Hell_drawFont( std.string.toString( Hell_GetGameflag(10) ) , 400, 200, 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( card[0].deg ) , 400, 200, 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( Hell_getMouseX ) , 400, 220, 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( Hell_getMouseY ) , 450, 220, 2 , 255,255,255);

		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		msec = game_time_count % 60;
		
		if ( iSceneStatus != SCENE.CLEAR )
		{
			str = std.string.format( "TIME %02d:%02d:%02d", min, sec, msec );			//time表示
			Hell_drawFont( str , 50, 30 , 2 , r,g,b);
			str = std.string.format( "%03d", cast(int)( (game_time_count + 59) / 60 ) );	//加点基準表示
			Hell_drawFont( str , 330, 30 , 2 , 255,255,0);
		}

		player_draw();
	}
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	//■	プレイヤーの表示 	110503-
	//■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■■
	void player_draw( )		
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("aira"
			, 200 - player[0].size * player[0].muki - ( player[0].size * ( zoome - 1 ))* player[0].muki
			, 200 - player[0].size					- ( player[0].size * ( zoome - 1 ))
			, 32 * player[0].ani
			, 32 *player[0].status
			, 32 , 32
			, player[0].muki * zoome , zoome
			, 0
			,255, 255, 255, 255 );
		
	}
	void star_draw( float sx , float sy ,int size , int deg )		//カードエフェクトの★
	{
		int j;
		for ( j = 0 ; j <= 12 ; j++ )
		{
		Hell_drawTexture("tama"
			, sx + field_x + 16 -2 + ( Hell_cosEx( j * 40 - size * 4 + deg ) ) * size 
			, sy + field_y + 16 -2 + ( Hell_sinEx( j * 40 - size * 4 ) ) * size 
			, 128 
			, 0
			, 4, 4
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
			if ( game_score > 30000 )
			{
			Hell_drawTexture("tama"
				, sx + field_x + 16 -2 + ( Hell_cosEx( j * 30 + size * 4 + deg ) ) * size * 1.5
				, sy + field_y + 16 -2 + ( Hell_sinEx( j * 30 + size * 4 ) ) * size * 1.5
				, 128 
				, 0
				, 4, 4
				, 1.0 , 1.0
				, 0
				,255, 255, 255, 255 );
			}
			if ( game_score > 60000 )
			{
			Hell_drawTexture("tama"
				, sx + field_x + 16 -2 + ( Hell_cosEx( j * 30 - size * 4 ) ) * size * 2
				, sy + field_y + 16 -2 + ( Hell_sinEx( j * 30 - size * 4 + deg ) ) * size * 2
				, 128 
				, 0
				, 4, 4
				, 1.0 , 1.0
				, 0
				,255, 255, 255, 255 );
			}
			if ( game_score > 90000 )
			{
			Hell_drawTexture("tama"
				, sx + field_x + 16 -2 + ( Hell_cosEx( j * 20 - size * 4 ) ) * size * 2
				, sy + field_y + 16 -2 + ( Hell_sinEx( j * 20 - size * 4 ) ) * size * 2
				, 128 
				, 0
				, 4, 4
				, 1.0 , 1.0
				, 0
				,255, 255, 255, 255 );
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの処理   #09A
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画 #09B
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	
}


